/*
 * Copyright (c) 2009, 2011-2013, 2015, 2018 Eike Stepper (Loehne, Germany) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Eike Stepper - initial API and implementation
 */
package org.eclipse.emf.cdo.tests.model2.impl;

import org.eclipse.emf.cdo.tests.model1.VAT;
import org.eclipse.emf.cdo.tests.model2.Model2Package;
import org.eclipse.emf.cdo.tests.model2.Unsettable1;

import org.eclipse.emf.internal.cdo.CDOObjectImpl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import java.util.Date;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Unsettable1</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#isUnsettableBoolean <em>Unsettable Boolean</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableByte <em>Unsettable Byte</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableChar <em>Unsettable Char</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableDate <em>Unsettable Date</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableDouble <em>Unsettable Double</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableFloat <em>Unsettable Float</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableInt <em>Unsettable Int</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableLong <em>Unsettable Long</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableShort <em>Unsettable Short</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableString <em>Unsettable String</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableVAT <em>Unsettable VAT</em>}</li>
 *   <li>{@link org.eclipse.emf.cdo.tests.model2.impl.Unsettable1Impl#getUnsettableElement <em>Unsettable Element</em>}</li>
 * </ul>
 *
 * @generated
 */
public class Unsettable1Impl extends CDOObjectImpl implements Unsettable1
{
  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  protected Unsettable1Impl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Model2Package.eINSTANCE.getUnsettable1();
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected int eStaticFeatureCount()
  {
    return 0;
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isUnsettableBoolean()
  {
    return (Boolean)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableBoolean(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableBoolean(boolean newUnsettableBoolean)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableBoolean(), newUnsettableBoolean);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableBoolean()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableBoolean());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableBoolean()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableBoolean());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public byte getUnsettableByte()
  {
    return (Byte)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableByte(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableByte(byte newUnsettableByte)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableByte(), newUnsettableByte);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableByte()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableByte());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableByte()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableByte());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public char getUnsettableChar()
  {
    return (Character)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableChar(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableChar(char newUnsettableChar)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableChar(), newUnsettableChar);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableChar()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableChar());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableChar()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableChar());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public Date getUnsettableDate()
  {
    return (Date)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDate(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableDate(Date newUnsettableDate)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDate(), newUnsettableDate);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableDate()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableDate());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableDate()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDate());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public double getUnsettableDouble()
  {
    return (Double)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDouble(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableDouble(double newUnsettableDouble)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDouble(), newUnsettableDouble);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableDouble()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableDouble());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableDouble()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableDouble());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public float getUnsettableFloat()
  {
    return (Float)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableFloat(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableFloat(float newUnsettableFloat)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableFloat(), newUnsettableFloat);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableFloat()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableFloat());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableFloat()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableFloat());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public int getUnsettableInt()
  {
    return (Integer)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableInt(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableInt(int newUnsettableInt)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableInt(), newUnsettableInt);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableInt()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableInt());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableInt()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableInt());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public long getUnsettableLong()
  {
    return (Long)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableLong(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableLong(long newUnsettableLong)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableLong(), newUnsettableLong);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableLong()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableLong());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableLong()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableLong());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public short getUnsettableShort()
  {
    return (Short)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableShort(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableShort(short newUnsettableShort)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableShort(), newUnsettableShort);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableShort()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableShort());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableShort()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableShort());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public String getUnsettableString()
  {
    return (String)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableString(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableString(String newUnsettableString)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableString(), newUnsettableString);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableString()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableString());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableString()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableString());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public VAT getUnsettableVAT()
  {
    return (VAT)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableVAT(), true);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableVAT(VAT newUnsettableVAT)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableVAT(), newUnsettableVAT);
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableVAT()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableVAT());
  }

  /**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableVAT()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableVAT());
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject getUnsettableElement()
  {
    return (EObject)eGet(Model2Package.eINSTANCE.getUnsettable1_UnsettableElement(), true);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUnsettableElement(EObject newUnsettableElement)
  {
    eSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableElement(), newUnsettableElement);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnsettableElement()
  {
    eUnset(Model2Package.eINSTANCE.getUnsettable1_UnsettableElement());
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnsettableElement()
  {
    return eIsSet(Model2Package.eINSTANCE.getUnsettable1_UnsettableElement());
  }

} // Unsettable1Impl
